/* Copyright (C) 2004 - 2007  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.db4ounit.jre12.collections;

import java.util.*;

import com.db4o.collections.facades.*;
import com.db4o.config.*;
import com.db4o.reflect.*;

import db4ounit.*;
import db4ounit.extensions.*;
import db4ounit.extensions.fixtures.*;


public class ArrayListTestCase extends AbstractDb4oTestCase implements OptOutCS{
    
    public static void main(String[] arguments) {
        new ArrayListTestCase().runSolo();
    }
    
    public static class Item {
        
        public ArrayList arrayList;
        
        public Item() {
        }
        
    }
    
    protected void configure(Configuration config) throws Exception {
        super.configure(config);
        config.objectClass(ArrayList.class).installCustomHandler(new VanillaClassHandler(){
            public ReflectClass classSubstitute() {
                return reflector().forClass(ArrayListFacade.class);
            }
        });
        config.objectClass(ArrayListFacade.class).installCustomHandler(new VanillaClassHandler(){
            public boolean ignoreAncestor() {
                return true;
            }
            
        });

    }
    
    public void testReplacement() throws Exception{
        Item item = new Item();
        ArrayList arrayList = new ArrayList();
        item.arrayList = arrayList;
        arrayList.add("One");
        store(item);
        
        reopen();
        
        Item retrievedItem = (Item) retrieveOnlyInstance(Item.class);
        ArrayList retrievedArrayList = retrievedItem.arrayList;
        Assert.isInstanceOf(ArrayListFacade.class, retrievedArrayList);
        
//        String str = (String) retrievedArrayList.get(0);
//        Assert.areEqual("One", str);
    }

}
